--- hedoProfiLine.py.bak	2011-10-24 12:18:11.351642512 +0100
+++ hedoProfiLine.py	2011-10-24 13:02:51.554289893 +0100
@@ -80,24 +80,19 @@
         ser.open()
 
         # Prepare a blank line
-        zeile = chr(1)
-        length = 84
-        while length:
-            zeile = zeile + chr(0)
-            length -= 1
+        cells = chr(HEDO_INIT) + chr(0) * (HEDO_CELL_COUNT + HEDO_STATUS_CELL_COUNT)
 
         # Send the blank line twice
-        ser.write(zeile)
+        ser.write(cells)
         ser.flush()
-        ser.write(zeile)
+        ser.write(cells)
         ser.flush()
 
         # Read out the input buffer
         ackS = ser.read(4)
-        for ack in ackS:
-            if ack == chr(HEDO_ACK):
-                log.debug(port + ": Acknowledge Byte detected")
-                return True
+        if chr(HEDO_INIT) in ackS:
+            log.debug(port + ": Acknowledge Byte detected")
+            return True
   
     except serial.SerialException, e:
         log.debug(str(e))
@@ -175,21 +170,18 @@
         return HEDO_CELL_COUNT
 
     def display(self, cells):
-        # every transmitted line consists of the preamble 0x01, the statusCells and the Cells
+        # every transmitted line consists of the preamble HEDO_INIT, the statusCells and the Cells
         line = chr(HEDO_INIT)
 
         # statusCells will be left empty
-        for cell in range(0, HEDO_STATUS_CELL_COUNT):
-            line += chr(0x00)
+        line += chr(0) * HEDO_STATUS_CELL_COUNT
 
-        # the cells information
-        for pos in range(0, len(cells)):
-            line += chr(cells[pos])
+        # add the actual cells
+        line += "".join(chr(cell) for cell in cells)
 
         # cells will be padded up to 1 + numStatusCells + numCells.
-        length = len(line)
-        for pos in range(length, 1 + HEDO_STATUS_CELL_COUNT + HEDO_CELL_COUNT):
-            line += chr(0x00)
+        ExpectedLength = 1 + HEDO_STATUS_CELL_COUNT + HEDO_CELL_COUNT
+        line += chr(0) * (expectedLength - len(line))
 
         self._ser.write(line)
 
